{

  DirectDraw.
:
    IDirectDraw4
    Surface' (Flip-)
    Surface'    
    Surface'    GDI
    Surface' (flip)
    /   Alt+TAB   Surface'

: JINX
EMail: aziz@telebot.com, error@softhome.net
CopyLeft 1999-2000.

}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,{  DirectDraw} DDraw;

type
  TForm1 = class(TForm)
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormPaint(Sender: TObject);
  private
    FDirectDraw: IDirectDraw4;           //  DirectDraw4
    FPrimarySurface: IDirectDrawSurface4; //  DirectDraw surface
    FBackSurface: IDirectDrawSurface4;    //  DirectDraw surface
    { Private declarations }
  public
    { Public declarations }
    procedure DirecDrawZapusk;
    procedure PodgotovkaSuface;
  end;

var
  Form1: TForm1;
  DDStarted : boolean = False;


implementation

{$R *.DFM}

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
hr : HResult;
begin
if Key=VK_ESCAPE then begin Close; exit end; ///  Escape
if Key<>VK_SPACE then exit;
if not DDStarted then begin ///    , ...
  ///  ..., 
  DirecDrawZapusk;
  PodgotovkaSuface;
  DDStarted:=True;
  exit;
end
else
  begin
  ///   Surface
  hr := FPrimarySurface.Flip(nil, 0);
    if (hr = DDERR_NOEXCLUSIVEMODE) then ///   Alt+TAB -     
     begin
     WaitMessage;
     end;
    if (hr = DDERR_SURFACELOST) then /// ,  Alt+Tab -   
    begin
      { Surface'}
      FDirectDraw.RestoreAllSurfaces;
      PodgotovkaSuface;
    end;
  end;
end;

procedure TForm1.DirecDrawZapusk;
var
  hr: HRESULT;
  SurfaceDesc: TDDSurfaceDesc2;// TDDSURFACEDESC2;
  DDSCaps: TDDSCAPS2;
  DD: IDirectDraw;
begin
///  ..., 
  hr := DirectDrawCreate(nil, DD, nil); /// DirectDraw
  if(hr = DD_OK) then begin
    //   IDirectDraw4
    DD.QueryInterface(IID_IDirectDraw4, FDirectDraw);
    //  DirecDraw1    
    DD:= nil;
    //       
    hr := FDirectDraw.SetCooperativeLevel(Handle, DDSCL_EXCLUSIVE or DDSCL_FULLSCREEN);
    if(hr = DD_OK) then begin
      hr := FDirectDraw.SetDisplayMode(640, 480, 8, 0,0 );  ///   640X480X8
      if(hr = DD_OK) then begin
        //   surface   back buffer'
        FillChar(SurfaceDesc,SizeOf(SurfaceDesc),0);
        SurfaceDesc.dwSize := SizeOf(SurfaceDesc);
        SurfaceDesc.dwFlags := DDSD_CAPS or DDSD_BACKBUFFERCOUNT ; ///    back buffer'
        SurfaceDesc.ddsCaps.dwCaps := DDSCAPS_PRIMARYSURFACE ////    Surface
                                      or DDSCAPS_FLIP        ////  Flip-
                                      or DDSCAPS_COMPLEX;    ////      Surface'
        SurfaceDesc.dwBackBufferCount := 1;                  ////     - 1
        hr := FDirectDraw.CreateSurface(SurfaceDesc, FPrimarySurface, nil); /// ,  Surface'     FPrimarySurface
        if(hr = DD_OK) then begin
          //      back buffer (-  Surface'a )
          ddscaps.dwCaps := DDSCAPS_BACKBUFFER;
          hr := FPrimarySurface.GetAttachedSurface(ddscaps, FBackSurface); ///    FBackSurface
          if(hr = DD_OK) then begin
          {  - Surface'  - }
            exit;
           end;
          end;
        end;
      end;
    end;
   {-   -     }
  MessageBox(Self.Handle, PChar('   DirectDraw! '+ ErrorString(Hr)),'ERROR', MB_OK);
  Close();
end;

procedure TForm1.PodgotovkaSuface;
var
  DC: HDC;
  i,j : integer;
  AdresVideo : PByteArray;
  SurfaceDesc: TDDSURFACEDESC2;
  HR : HResult;
begin
{ -  Surface'   }

////     ( Surface)
FillChar(SurfaceDesc,SizeOf(SurfaceDesc),0); SurfaceDesc.dwSize:=SizeOf(SurfaceDesc);
HR:=FPrimarySurface.Lock(nil,SurfaceDesc,{DDLOCK_WAIT or} DDLOCK_SURFACEMEMORYPTR,0);
if (HR=DD_OK) then BEgIN
AdresVideo:=SurfaceDesc.lpSurface;
  for i := 0 to SurfaceDesc.dwHeight-1 do
  begin
     for  j:= 0 to SurfaceDesc.dwWidth-1 do
     begin
      AdresVideo[j+i*SurfaceDesc.lPitch]:=$FF;
     end;
  end;
FPrimarySurface.Unlock(nil);
EnD;

////   ( Surface)
FillChar(SurfaceDesc,SizeOf(SurfaceDesc),0); SurfaceDesc.dwSize:=SizeOf(SurfaceDesc);
HR:=FBackSurface.Lock(nil,SurfaceDesc,{DDLOCK_WAIT or} DDLOCK_SURFACEMEMORYPTR,0);
if (HR=DD_OK) then BEgIN
AdresVideo:=SurfaceDesc.lpSurface;
  for i := 0 to SurfaceDesc.dwHeight-1 do
  begin
     for  j:= 0 to SurfaceDesc.dwWidth-1 do
     begin
      AdresVideo[j+i*SurfaceDesc.lPitch]:=$AA;
     end;
  end;
FBackSurface.Unlock(nil);
EnD;


  if (FPrimarySurface.GetDC(DC) = DD_OK) then begin
  {   1- surface,  GDI- TextOut}
    SetBkColor(DC, RGB(255, 255, 255));
    SetTextColor(DC, RGB(255, 0, 0));
    TextOut(DC, 10, 20, ' Surface -   - Esc - ', Length(' Surface -   - Esc - '));
    FPrimarySurface.ReleaseDC(DC);
  end;

  if (FBackSurface.GetDC(DC) = DD_OK) then begin
  {   2- surface,  GDI- TextOut}
    SetBkColor(DC, RGB(0, 0, 0));
    SetTextColor(DC, RGB(0, 255, 255));
    TextOut(DC, 10, 440, ' Surface -   - Esc - ', Length(' Surface -   - Esc - '));
    FBackSurface.ReleaseDC(DC);
  end;

      {
      :
        !     ,  
           Lock  GetDC  Win16Mutex    ,
          Windows . (  Kernel debuggers)
              Lock  UnLock -      
           DDLOCK_NOSYSLOCK    Lock.
      }
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if(FDirectDraw <> nil) then begin
    FDirectDraw.FlipToGDISurface;  ///   Surface   GDI
    FDirectDraw.SetCooperativeLevel(Handle, DDSCL_NORMAL);
    if FBackSurface <> nil then
      FBackSurface := nil;
    if FPrimarySurface <> nil then
      FPrimarySurface := nil;
    FDirectDraw := nil;
  end;

end;


procedure TForm1.FormPaint(Sender: TObject);
begin
if not DDStarted then begin
Self.Canvas.Font.Color:=clAqua;
Self.Canvas.Font.Size:=18;
Self.Canvas.TextOut(25,25,' ')
end;
end;

end.
